#!/usr/bin/python
# -*- coding: cp1252 -*-

# Copyright (c) Gerald Uhrhan 2004,2005,2006,2012
# GNU public license
# ding4win comes with ABSOLUTELY NO WARRANTY.



__author__ = "Gerald Uhrhan"
__date__ = "20 Juni 2012"
__version__ = "0.6.2"

import sys, re, os, tkFont,tkMessageBox
from string import *
from Tkinter import *
 

CASESENSITIVE = 1
NOCASESENSITIVE = 2
    
EXAKT = 1
ENTHALTEN = 2
WORTANFANG = 3
WORTENDE = 4
    

class Dingwin:
    def __init__(self, datei):
        self.dateiname = datei
        self.zeilen = []
        self.suchStr =''
        self.dictyp = ''
 
    def suchen(self, suchString, nocase=None, exact=None):
        #print nocase
        '''Sucht mit dem Suchmuster nach Treffer im Dic '''
        self.suchStr = suchString

        alias = {'"u': u'', '"a': u'', '"o': u'',
                 '"U': u'', '"A': u'', '"O': u'',
                 '"s': u''}

        for k, v in alias.iteritems():
            self.suchStr = self.suchStr.replace(k, v)

        self.suchStr = self.suchStr.encode('utf-8')
            
        suchString = self.suchStr
        print 'Suche: ', self.suchStr # fhrt bei pythonw.exe zu Unicode-Fehler
  
        # Suchmuster fuer RegExp
        if nocase == CASESENSITIVE:
            wCase = re.U
        else:
            wCase = re.U + re.I

        if exact == EXAKT:
            wStart = '(^|[^\w\[])'
            wEnd = '([^\w\]]|$)'
        elif exact == WORTANFANG:
            wStart = '(^|[^\w\[])'
            wEnd = ''
        elif exact == WORTENDE:
            wStart = ''
            wEnd = '([^\w\]]|$)'
        else:
            wStart = ''
            wEnd = ''

        print wStart+self.suchStr+wEnd

        muster = re.compile(wStart+self.suchStr+wEnd, wCase)
        try:
            datei = open(self.dateiname, 'r')
            zeile = datei.readline()
            while zeile:
                if re.search('^#', zeile) or zeile == '':
                    if re.search('dict.cc', zeile):
                        self.dictyp = 'dict'
                    elif re.search('dict.tu-chemnitz.de', zeile):
                        self.dictyp = 'ding'
                elif muster.search(zeile): # wenn ein Treffer
                    zeile = strip(zeile)
                    self.zeilen.append(zeile)
                zeile = datei.readline()
                
            datei.close()
        except IOError:
            print self.dateiname, "ist nicht lesbar"
            sys.exit(1)

        print 'Dicttyp: '+self.dictyp
        return self.suchStr
    

    def sort(self):
        '''Beurteilung der Relevanz eines Treffers '''
        '''sortieren der Treffer'''
        zeilenTmp = []
        for zeile in self.zeilen:
            if self.dictyp == 'dict':
                zeile = split(zeile, chr(9))
            else:
                zeile = split(zeile, '::')
            #print zeile

            pos = '1'
            laenge = 0
            ret = re.search(self.suchStr, zeile[0])
            if ret:
                num = ret.start(0)
                #print 'NUM:'+str(num)
                ret = re.search('(^|[^\w\[])'+self.suchStr+'([^\w\]]|$)', zeile[0])
                if ret:
                    pos = '0'
                    laenge = len(zeile[0])
            else:
                num = 1000

            ret = re.search(self.suchStr, strip(zeile[1]))
            if ret:
                num1 = ret.start(0)
                ret = re.search('(^|[^\w\[])'+self.suchStr+'([^\w\]]|$)', zeile[1])
                if ret:
                    pos = '0'
                    laenge = len(zeile[1])
            else:
                num1 = 1000

            if num > num1:
                num = num1
            zeilenTmp.append(pos + zfill(str(num),4) + zfill(str(laenge),3) + '::' + strip(zeile[0]) + '::' + strip(zeile[1]))
            #print pos + zfill(str(num),4) + zfill(str(laenge),3) + '::' + strip(zeile[0]) + '::' + strip(zeile[1]) + "\n"
        self.zeilen = zeilenTmp
        self.zeilen.sort()    


    def getRaw(self):
        '''bergibt die rohe Trefferliste'''
        '''wenn SIe sortiert sein soll, vorher sort aufrufen'''
        
        return self.zeilen


    def getHtml(self):
        '''die Zukunft'''
        pass


    

#----------------- die graphische Ausgabe (GUI) ----------------------------------------


class GuiTk:
    def __init__(self, window):
        self.dictpath = ''
        
        self.case=NOCASESENSITIVE
        self.exact=ENTHALTEN
        
        self.win = window
        self.win.title('ding4win -- v'+__version__)
        self.win.protocol('WM_DELETE_WINDOW', self.beenden)
        self.win.bind('<Escape>', self.beenden)
        
        self.frmSuchen = Frame()                    # Eingabeframe
        self.frmSuchen.pack(side='top', fill='x', pady=2)

        self.txtSuchen = Entry(self.frmSuchen, bd=1, width=35)
        self.txtSuchen.bind('<Return>',self.suchen)
        self.txtSuchen.pack(side="left")
        self.txtSuchen.focus_set()
    
        self.lblSelDict = Label(self.frmSuchen, bd=1, text=" <leer> ", relief=SUNKEN, pady=0)
        self.lblSelDict.bind("<Button-1>", self.popupSelDict)
        self.lblSelDict.bind("<Button-3>", self.popupSelDict)
        self.lblSelDict.pack(side="left")

        self.butSuchen = Button(self.frmSuchen, bd=1, text=" Suchen ", command=self.suchen, pady=0)
        self.butSuchen.pack(side="left")

        self.butAbout = Button(self.frmSuchen, bd=1, text=" Info ", command=self.about, pady=0)
        self.butAbout.pack(side=RIGHT)



        self.frmStatus = Frame()                    # Fussleiste
        self.frmStatus.pack(side='bottom', fill='both')
        self.lblTreffer = Label(self.frmStatus, text=' Suchbegriff eingeben ', relief=SUNKEN, bd=1, anchor=W)
        self.lblTreffer.pack(side='left')

        self.lblSizer = Label(self.frmStatus, text='', padx=9, bd=0)
        self.lblSizer.pack(side='right')
        self.butBeenden = Button(self.frmStatus, bd=1, text="Beenden", command=self.beenden, pady=0)
        self.butBeenden.pack(side="right")
        self.lblCase = Label(self.frmStatus, text='CASE INSENSITIVE', relief=SUNKEN, bd=1, anchor=W, width=17)
        self.lblCase.bind("<Button-1>", self.changeCase)
        self.lblCase.bind("<Button-3>", self.changeCase)
        self.lblCase.pack(side='right')
       
        self.lblExact = Label(self.frmStatus, text='ENTHALTEN', relief=SUNKEN, bd=1, anchor=W, width=13)
        self.lblExact.bind("<Button-1>", self.popup)
        self.lblExact.bind("<Button-3>", self.popup)
        self.lblExact.pack(side='right')
        

  
        self.frmAusgabe = Frame()                    # Ausgabeframe
        self.frmAusgabe.pack(side='top', fill='both', expand=1, padx=0, pady=1)
        self.lstAusgabe = Text(self.frmAusgabe, font=('Courier', 10),
            wrap=NONE, state=DISABLED, selectbackground='grey', selectforeground='red')
        self.result_scr = Scrollbar(self.frmAusgabe,
            orient='vertical', command=self.lstAusgabe.yview, bd=1, width=16)
        self.scrAusgabeH = Scrollbar(self.frmAusgabe,
            orient='horizontal', command=self.lstAusgabe.xview, bd=1, width=16)
        self.lstAusgabe.config(yscrollcommand=self.result_scr.set)
        self.lstAusgabe.config(xscrollcommand=self.scrAusgabeH.set)
        self.result_scr.grid(row=0,column=1,sticky=N+S)
        self.scrAusgabeH.grid(row=1,column=0,sticky=E+W)
        self.lstAusgabe.config(width=80, height=20, bd=1)
        self.lstAusgabe.grid(row=0,column=0,sticky=E+W+N+S)
        self.frmAusgabe.columnconfigure(0, weight=1, minsize=0)
        self.frmAusgabe.rowconfigure(0, weight=1, minsize=0)
        self.zentrieren(self.win)
        self.win.update()
        self.win.bind('<Configure>', self.winGeoChange, '+')

        self.lstAusgabe.tag_config('w', background='white')
        self.lstAusgabe.tag_config('g', background='#eeeeee')
        self.lstAusgabe.tag_config('b', foreground='blue')
        
        bold_font = tkFont.Font(self.lstAusgabe, self.lstAusgabe.cget("font"))
        bold_font.configure(weight="bold")
        self.lstAusgabe.tag_configure('bt', font=bold_font)
        
        italic_font = tkFont.Font(self.lstAusgabe, self.lstAusgabe.cget("font"))
        italic_font.configure(slant='italic')
        self.lstAusgabe.tag_configure('it', font=italic_font)

        self.menuExact = Menu(window, tearoff=0)
        self.menuExact.add_command(label="EXAKT", command=self.fktExakt)
        self.menuExact.add_command(label="ENTHALTEN", command=self.fktEnthalten)
        self.menuExact.add_command(label="WORTANFANG", command=self.fktWortanfang)
        self.menuExact.add_command(label="WORTENDE", command=self.fktWortende)

        file_list = []
        root_dir = sys.path[0]
        for path in os.listdir(root_dir):
            full_path = os.path.join(root_dir, path)
            #print os.path.isfile(full_path)
            #sys.exit(1) 
            if os.path.isfile(full_path) and full_path.endswith('txt'):
                print full_path 
                # create list of (filename, dir) tuples
                file_list.append((path, full_path))

        #if len(file_list) == 0:
        if file_list == []:
            tkMessageBox.showinfo("Error", 'Kann kein Wrterbuch finden. Programm wird beendet!')
            self.beenden

        self.menuDict = Menu(window, tearoff=0)
        for dicName in file_list:
            self.menuDict.add_command(label=dicName[0].split('.')[0], command=lambda name=dicName[0].split('.')[0],path=dicName[1]: self.fktSelDict(name,path))
        self.lblSelDict.config(text=' '+file_list[0][0].split('.')[0]+' ')
        self.dictpath = file_list[0][1]
        print file_list[0][0].split('.')[0]


    def popupSelDict(self, event):
        self.menuDict.post(event.x_root, event.y_root)
    def fktSelDict(self,dicName,dicPath):
        self.lblSelDict.config(text=' '+dicName+' ')
        self.dictpath = dicPath
        if not self.txtSuchen.get()=='':
            self.suchen()


    def popup(self, event):
        self.menuExact.post(event.x_root, event.y_root)
        
    def fktExakt(self):
        self.lblExact.config(text='EXAKT')
        self.exact = EXAKT
    def fktEnthalten(self):
        self.lblExact.config(text='ENTHALTEN')
        self.exact = ENTHALTEN
    def fktWortanfang(self):
        self.lblExact.config(text='WORTANFANG')
        self.exact = WORTANFANG
    def fktWortende(self):
        self.lblExact.config(text='WORTENDE')
        self.exact = WORTENDE
        

    def changeCase(self, e):
        if self.lblCase.cget('text')== 'CASESENSITIVE':
            self.lblCase.config(text='CASE INSENSITIVE')
            self.case = NOCASESENSITIVE
        else:
            self.lblCase.config(text='CASESENSITIVE')
            self.case = CASESENSITIVE


        

    def zentrieren(self, winObj):
        '''zentriert das Hauptfenster in die Bildschirmmitte.
        Arbeitsplaetze mit mehreren Bildschirme sind noch nicht beruecksichtigt'''
        winObj.update_idletasks()
        x = winObj.winfo_screenwidth()/2 - winObj.winfo_reqwidth()/2
        y = winObj.winfo_screenheight()/2 - winObj.winfo_height()/2
        winObj.wm_geometry( '+%d+%d' % (x, y) )

    def beenden(self, event=None ):
        self.win.destroy()

    def suchen(self, event=None):
        suchString = self.txtSuchen.get()
        
        if len(self.txtSuchen.get())== 0:
            self.lblTreffer.config(text=' Keine Treffer ')
            return
        self.butSuchen.config(state='disabled')
        self.lstAusgabe.config(state=NORMAL)
        self.lblTreffer.config(text=' Suche %s ... ' % self.txtSuchen.get())
        self.win.update()
        self.lstAusgabe.delete(0.0, 'end')
        ding = Dingwin(self.dictpath)
        suchString = ding.suchen(suchString, self.case, self.exact)
        #suchString = ding.suchen(suchString)
        ding.sort()
        farbe = 'w'
        zaehler=0
        for zeile in ding.getRaw():
            zaehler += 1
            zeile = split(zeile, '::')
            zeile1 = split(zeile[1], '|')
            zeile2 = split(zeile[2], '|')
            if farbe == 'g':
                farbe = 'w'
                trenn = 'g'
            else:
                farbe = 'g'
                trenn = 'w'
            self.lstAusgabe.insert('end', zeile1[0] + '\t', farbe)
            self.lstAusgabe.insert('end', ' ', trenn)
            self.lstAusgabe.insert('end', zeile2[0] +'\n', farbe)
            for i in range(1, len(zeile1)):
                self.lstAusgabe.insert('end', '  -' + strip(zeile1[i]) + '\t', farbe)
                self.lstAusgabe.insert('end', ' ', trenn)
                self.lstAusgabe.insert('end', '  -' + strip(zeile2[i]) +'\n', farbe)
            if zaehler > 200: break
        
        if zaehler > 200:
            self.lblTreffer.config(text=' Es gibt %s Treffer, 200 werden angezeigt ' % len(ding.getRaw()))
        else:
            self.lblTreffer.config(text=' %s Treffer ' % len(ding.getRaw()))
        self.butSuchen.config(state='normal')
        self.lstAusgabe.config(state=DISABLED)
        self.txtSuchen.delete(0, END)
        self.txtSuchen.insert(0, suchString)
        self.txtSuchen.focus_set()
        self.txtSuchen.select_range(0, END)# Suchtext im Eingabefeld markieren

        # Suchmuster im Ausgabefeld markieren
        start = 1.0
        muster = self.txtSuchen.get()
        musterLen = str(len(muster))
        while 1:
            pos = self.lstAusgabe.search(muster, start, END, nocase=1, regexp=1)
            if not pos:
                break
            self.lstAusgabe.tag_add('b', pos, pos + '+' + musterLen + 'c')
            start = pos + '+1c'

        # 
        start = 1.0
        muster = r"{\w+}"
        #muster = r"\{[^\}]*\}"
        count = IntVar()
        while 1:
            pos = self.lstAusgabe.search(muster, start, END, nocase=1, regexp=1,count=count)
            if not pos:
                break
            self.lstAusgabe.tag_add('it', pos, pos + '+' + str(count.get()) + 'c')
            start = pos + '+1c'
        
            
        

    def winGeoChange(self, e):
        # Tabulator in die Mitte der Ausgabe setzen
        breite = int(self.lstAusgabe.winfo_width()/2)
        self.lstAusgabe.config(tabs=breite)



    def about(self):
        winAbout = DialogAbout(self.win)


        

class DialogAbout:
    def __init__(self, win):
        '''ffnet einen about-Dialog'''
        infoText = '\nding4win\n\n'
        infoText += 'Autor: ' + __author__ + '\n'
        infoText += 'Version: ' + __version__ + '\n'
        infoText += 'Datum: ' + __date__ + '\n'
        infoText += '' + '\n'
        infoText += '' + '\n'
        
        self.winAbout = Toplevel(win)
        self.winAbout.title('ding4win - About')
        self.winAbout.transient(win)
        self.winAbout.grab_set()#Modal
        self.winAbout.protocol("WM_DELETE_WINDOW", self.beenden)
        self.winAbout.bind('<Return>', self.beenden)
        self.winAbout.bind('<Escape>', self.beenden)
        self.winAbout.resizable(height=FALSE, width=FALSE)
        self.zentrieren(self.winAbout)

        lblAbout = Label(self.winAbout, text=infoText, relief=GROOVE, pady=30, padx=30)
        lblAbout.pack(side=TOP, fill=BOTH, expand=1)

        butOk = Button(self.winAbout, text=' OK ', command=self.beenden)
        butOk.pack(side=BOTTOM)
        butOk.focus_set()

        self.winAbout.wait_window()
        
    def beenden(self, e=None):
        self.winAbout.destroy()

    def zentrieren(self, winObj, inObj=None):
        '''zentriert das Hauptfenster in die Bildschirmmitte.'''
        winObj.update_idletasks()
  
        if inObj is None:
            x = winObj.winfo_screenwidth()/2 - winObj.winfo_reqwidth()/2
            y = winObj.winfo_screenheight()/2 - winObj.winfo_height()/2
        else:
            pass # muss noch gemacht werden
        
        winObj.wm_geometry( '+%d+%d' % (x, y) )
    
        

if  __name__ == "__main__":
    
    win = Tk()
    gui = GuiTk(win)
    win.mainloop()
    


    
